<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLinhasContactoEntidadesERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLinhasContactoEntidadesERP
 * @subpackage Arrays
 */
class ArrayOfLinhasContactoEntidadesERP extends AbstractStructArrayBase
{
    /**
     * The LinhasContactoEntidadesERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LinhasContactoEntidadesERP[]
     */
    public $LinhasContactoEntidadesERP;
    /**
     * Constructor method for ArrayOfLinhasContactoEntidadesERP
     * @uses ArrayOfLinhasContactoEntidadesERP::setLinhasContactoEntidadesERP()
     * @param \StructType\LinhasContactoEntidadesERP[] $linhasContactoEntidadesERP
     */
    public function __construct(array $linhasContactoEntidadesERP = array())
    {
        $this
            ->setLinhasContactoEntidadesERP($linhasContactoEntidadesERP);
    }
    /**
     * Get LinhasContactoEntidadesERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LinhasContactoEntidadesERP[]|null
     */
    public function getLinhasContactoEntidadesERP()
    {
        return isset($this->LinhasContactoEntidadesERP) ? $this->LinhasContactoEntidadesERP : null;
    }
    /**
     * Set LinhasContactoEntidadesERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasContactoEntidadesERP[] $linhasContactoEntidadesERP
     * @return \ArrayType\ArrayOfLinhasContactoEntidadesERP
     */
    public function setLinhasContactoEntidadesERP(array $linhasContactoEntidadesERP = array())
    {
        foreach ($linhasContactoEntidadesERP as $arrayOfLinhasContactoEntidadesERPLinhasContactoEntidadesERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfLinhasContactoEntidadesERPLinhasContactoEntidadesERPItem instanceof \StructType\LinhasContactoEntidadesERP) {
                throw new \InvalidArgumentException(sprintf('The LinhasContactoEntidadesERP property can only contain items of \StructType\LinhasContactoEntidadesERP, "%s" given', is_object($arrayOfLinhasContactoEntidadesERPLinhasContactoEntidadesERPItem) ? get_class($arrayOfLinhasContactoEntidadesERPLinhasContactoEntidadesERPItem) : gettype($arrayOfLinhasContactoEntidadesERPLinhasContactoEntidadesERPItem)), __LINE__);
            }
        }
        if (is_null($linhasContactoEntidadesERP) || (is_array($linhasContactoEntidadesERP) && empty($linhasContactoEntidadesERP))) {
            unset($this->LinhasContactoEntidadesERP);
        } else {
            $this->LinhasContactoEntidadesERP = $linhasContactoEntidadesERP;
        }
        return $this;
    }
    /**
     * Add item to LinhasContactoEntidadesERP value
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasContactoEntidadesERP $item
     * @return \ArrayType\ArrayOfLinhasContactoEntidadesERP
     */
    public function addToLinhasContactoEntidadesERP(\StructType\LinhasContactoEntidadesERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LinhasContactoEntidadesERP) {
            throw new \InvalidArgumentException(sprintf('The LinhasContactoEntidadesERP property can only contain items of \StructType\LinhasContactoEntidadesERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LinhasContactoEntidadesERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LinhasContactoEntidadesERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LinhasContactoEntidadesERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LinhasContactoEntidadesERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LinhasContactoEntidadesERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LinhasContactoEntidadesERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LinhasContactoEntidadesERP
     */
    public function getAttributeName()
    {
        return 'LinhasContactoEntidadesERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLinhasContactoEntidadesERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
